package org.projectopen.timesheet;

/*
 * Copyright (C) 2010 ]project-open[ 
 *
 * This program is free software. You can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2 of the License, or (at your option)
 * any later version. This program is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * @author Frank Bergmann (frank.bergmann@project-open.com)
 * 
 */

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ProjopHour extends ProjopObject {
	
	 public ProjopHour() {
			super("im_hour");
	}
 	
	/*
	 * Create a new Hour from a list of MyHours report:
	 * <row>
	 * 		<hour_id>45624</hour_id>
	 * 		<user_id>625</Hour_name>
	 * 		<project_id>12345</level>
	 * 		<day>2010-01-01</Hour_type>
	 * </row>
	 */
    public static ProjopHour hourFromMyHoursXML (Element hourEl) {
    	
		
		//Create a new object
		ProjopHour h = new ProjopHour();
		int hourId = getIntValue(hourEl,"hour_id");
		h.setObjectId(hourId);
	
		// Iterate through the list of <row> entries, 
		// adding the data to the list of projects.
		NodeList nl = hourEl.getChildNodes();
		if(nl != null && nl.getLength() > 0) {
			for(int i = 0 ; i < nl.getLength();i++) {				
				Node el = (Node)nl.item(i);
		        int type = el.getNodeType();
		        
		        // skip everything except for element nodes ("real" nodes).
		        if (type != Node.ELEMENT_NODE) { continue; }
		        
				String value = el.getTextContent();
				String name = el.getNodeName();
				h.set(name, value);
			}
		}
		return h;
    }

}
